wxWidgets: wxKeyEvent Class Reference

| Version: 3.1.5

Loading...
Searching...
No Matches
Public Member Functions | List of all members
wxKeyEvent Class Reference
Class List by Category » Events

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.1/wxWidgets3.1-3.1.5-4.x86_64/src/wxWidgets-3.1.5/interface/wx/event.h>`

Inheritance diagram for wxKeyEvent:
[legend]

## Detailed Description

This event class contains information about key press and release events.

The main information carried by this event is the key being pressed or released. It can be accessed using either GetKeyCode() function or GetUnicodeKey(). For the printable characters, the latter should be used as it works for any keys, including non-Latin-1 characters that can be entered when using national keyboard layouts. GetKeyCode() should be used to handle special characters (such as cursor arrows keys or `HOME` or `INS` and so on) which correspond to wxKeyCode enum elements above the `WXK_START` constant. While GetKeyCode() also returns the character code for Latin-1 keys for compatibility, it doesn't work for Unicode characters in general and will return `WXK_NONE` for any non-Latin-1 ones. For this reason, it's recommended to always use GetUnicodeKey() and only fall back to GetKeyCode() if GetUnicodeKey() returned `WXK_NONE` meaning that the event corresponds to a non-printable special keys.

While both of these functions can be used with the events of `wxEVT_KEY_DOWN`, `wxEVT_KEY_UP` and `wxEVT_CHAR` types, the values returned by them are different for the first two events and the last one. For the latter, the key returned corresponds to the character that would appear in e.g. a text zone if the user pressed the key in it. As such, its value depends on the current state of the Shift key and, for the letters, on the state of Caps Lock modifier. For example, if `A` key is pressed without Shift being held down, wxKeyEvent of type `wxEVT_CHAR` generated for this key press will return (from either GetKeyCode() or GetUnicodeKey() as their meanings coincide for ASCII characters) key code of 97 corresponding the ASCII value of `a`. And if the same key is pressed but with Shift being held (or Caps Lock being active), then the key could would be 65, i.e. ASCII value of capital `A`.

However for the key down and up events the returned key code will instead be `A` independently of the state of the modifier keys i.e. it depends only on physical key being pressed and is not translated to its logical representation using the current keyboard state. Such untranslated key codes are defined as follows:

- For the letters they correspond to the upper case value of the letter.
- For the other alphanumeric keys (e.g. `7` or `+`), the untranslated key code corresponds to the character produced by the key when it is pressed without Shift. E.g. in standard US keyboard layout the untranslated key code for the key `=/+` in the upper right corner of the keyboard is 61 which is the ASCII value of `=`.
- For the rest of the keys (i.e. special non-printable keys) it is the same as the normal key code as no translation is used anyhow.

Notice that the first rule applies to all Unicode letters, not just the usual Latin-1 ones. However for non-Latin-1 letters only GetUnicodeKey() can be used to retrieve the key code as GetKeyCode() just returns `WXK_NONE` in this case.

To summarize: you should handle `wxEVT_CHAR` if you need the translated key and `wxEVT_KEY_DOWN` if you only need the value of the key itself, independent of the current keyboard state.

Note
  Not all key down events may be generated by the user. As an example, `wxEVT_KEY_DOWN` with `=` key code can be generated using the standard US keyboard layout but not using the German one because the `=` key corresponds to Shift-0 key combination in this layout and the key code for it is `0`, not `=`. Because of this you should avoid requiring your users to type key events that might be impossible to enter on their keyboard.

Another difference between key and char events is that another kind of translation is done for the latter ones when the Control key is pressed: char events for ASCII letters in this case carry codes corresponding to the ASCII value of Ctrl-Latter, i.e. 1 for Ctrl-A, 2 for Ctrl-B and so on until 26 for Ctrl-Z. This is convenient for terminal-like applications and can be completely ignored by all the other ones (if you need to handle Ctrl-A it is probably a better idea to use the key event rather than the char one). Notice that currently no translation is done for the presses of ``[, `\`, ``], `^` and `_` keys which might be mapped to ASCII values from 27 to 31. Since version 2.9.2, the enum values `WXK_CONTROL_A` - `WXK_CONTROL_Z` can be used instead of the non-descriptive constant values 1-26.

Finally, modifier keys only generate key events but no char events at all. The modifiers keys are `WXK_SHIFT`, `WXK_CONTROL`, `WXK_ALT` and various `WXK_WINDOWS_XXX` from wxKeyCode enum.

Modifier keys events are special in one additional aspect: usually the keyboard state associated with a key press is well defined, e.g. wxKeyboardState::ShiftDown() returns `true` only if the Shift key was held pressed when the key that generated this event itself was pressed. There is an ambiguity for the key press events for Shift key itself however. By convention, it is considered to be already pressed when it is pressed and already released when it is released. In other words, `wxEVT_KEY_DOWN` event for the Shift key itself will have `wxMOD_SHIFT` in GetModifiers() and ShiftDown() will return true while the `wxEVT_KEY_UP` event for Shift itself will not have `wxMOD_SHIFT` in its modifiers and ShiftDown() will return false.

Tip: You may discover the key codes and modifiers generated by all the keys on your system interactively by running the page_samples_keyboard wxWidgets sample and pressing some keys in it.

Note
  If a key down (`EVT_KEY_DOWN`) event is caught and the event handler does not call `event.Skip()` then the corresponding char event (`EVT_CHAR`) will not happen. This is by design and enables the programs that handle both types of events to avoid processing the same key twice. As a consequence, if you do not want to suppress the `wxEVT_CHAR` events for the keys you handle, always call `event.Skip()` in your `wxEVT_KEY_DOWN` handler. Not doing may also prevent accelerators defined using this key from working.
  If a key is maintained in a pressed state, you will typically get a lot of (automatically generated) key down events but only one key up one at the end when the key is released so it is wrong to assume that there is one up event corresponding to each down one.
  For Windows programmers: The key and char events in wxWidgets are similar to but slightly different from Windows `WM_KEYDOWN` and `WM_CHAR` events. In particular, Alt-x combination will generate a char event in wxWidgets (unless it is used as an accelerator) and almost all keys, including ones without ASCII equivalents, generate char events too.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxKeyEvent& event)

Event macros:

- EVT_KEY_DOWN(func):
  Process a `wxEVT_KEY_DOWN` event (any key has been pressed). If this event is handled and not skipped, `wxEVT_CHAR` will not be generated at all for this key press (but `wxEVT_KEY_UP` will be).
- EVT_KEY_UP(func):
  Process a `wxEVT_KEY_UP` event (any key has been released).
- EVT_CHAR(func):
  Process a `wxEVT_CHAR` event.
- EVT_CHAR_HOOK(func):
  Process a `wxEVT_CHAR_HOOK` event. Unlike all the other key events, this event is propagated upwards the window hierarchy which allows intercepting it in the parent window of the focused window to which it is sent initially (if there is no focused window, this event is sent to the wxApp global object). It is also generated before any other key events and so gives the parent window an opportunity to modify the keyboard handling of its children, e.g. it is used internally by wxWidgets in some ports to intercept pressing Esc key in any child of a dialog to close the dialog itself when it's pressed. By default, if this event is handled, i.e. the handler doesn't call wxEvent::Skip(), neither `wxEVT_KEY_DOWN` nor `wxEVT_CHAR` events will be generated (although `wxEVT_KEY_UP` still will be), i.e. it replaces the normal key events. However by calling the special DoAllowNextEvent() method you can handle `wxEVT_CHAR_HOOK` and still allow normal events generation. This is something that is rarely useful but can be required if you need to prevent a parent `wxEVT_CHAR_HOOK` handler from running without suppressing the normal key events. Finally notice that this event is not generated when the mouse is captured as it is considered that the window which has the capture should receive all the keyboard events too without allowing its parent wxTopLevelWindow to interfere with their processing.
  See also
    wxKeyboardState

  ##

Library: wxCore

<>< =''>:</>&;&;< =''>\ </></>

## Public Member Functions
| wxKeyEvent (wxEventType keyEventType=wxEVT_NULL)
| Constructor.
int | GetKeyCode () const
| Returns the key code of the key that generated this event.
bool | IsKeyInCategory (int category) const
| Returns true if the key is in the given key category.
wxPoint | GetPosition () const
| Obtains the position (in client coordinates) at which the key was pressed.
void | GetPosition (wxCoord *x, wxCoord *y) const
wxUint32 | GetRawKeyCode () const
| Returns the raw key code for this event.
wxUint32 | GetRawKeyFlags () const
| Returns the low level key flags for this event.
wxChar | GetUnicodeKey () const
| Returns the Unicode character corresponding to this key event.
wxCoord | GetX () const
| Returns the X position (in client coordinates) of the event.
wxCoord | GetY () const
| Returns the Y position (in client coordinates) of the event.
void | DoAllowNextEvent ()
| Allow normal key events generation.
bool | IsNextEventAllowed () const
| Returns true if DoAllowNextEvent() had been called, false by default.
Public Member Functions inherited from wxEvent
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor.
virtual wxEvent * | Clone () const =0
| Returns a copy of the event.
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any.
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`.
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event.
int | GetId () const
| Returns the identifier associated with this event, such as a button command id.
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler.
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise.
long | GetTimestamp () const
| Gets the timestamp for the event.
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false.
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation).
void | SetEventObject (wxObject *object)
| Sets the originating object.
void | SetEventType (wxEventType type)
| Sets the event type.
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id.
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event.
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0.
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns.
int | StopPropagation ()
| Stop the event from propagating to its parent window.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.
Public Member Functions inherited from wxKeyboardState
| wxKeyboardState (bool controlDown=false, bool shiftDown=false, bool altDown=false, bool metaDown=false)
| Constructor initializes the modifier key settings.
int | GetModifiers () const
| Return the bit mask of all pressed modifier keys.
bool | HasAnyModifiers () const
| Returns true if any modifiers at all are pressed.
bool | HasModifiers () const
| Returns true if Control or Alt are pressed.
bool | ControlDown () const
| Returns true if the Control key or Apple/Command key under macOS is pressed.
bool | RawControlDown () const
| Returns true if the Control key (also under macOS).
bool | ShiftDown () const
| Returns true if the Shift key is pressed.
bool | MetaDown () const
| Returns true if the Meta/Windows/Apple key is pressed.
bool | AltDown () const
| Returns true if the Alt key is pressed.
bool | CmdDown () const
| Returns true if the key used for command accelerators is pressed.
void | SetControlDown (bool down)
void | SetRawControlDown (bool down)
void | SetShiftDown (bool down)
void | SetAltDown (bool down)
void | SetMetaDown (bool down)

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.
Protected Attributes inherited from wxEvent
int | m_propagationLevel
| Indicates how many levels the event can propagate.
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Constructor & Destructor Documentation

## ◆ wxKeyEvent()

wxKeyEvent::wxKeyEvent | ( | wxEventType | keyEventType = wxEVT_NULL | ) |

Constructor.

Currently, the only valid event types are `wxEVT_CHAR` and `wxEVT_CHAR_HOOK`.

## Member Function Documentation

## ◆ DoAllowNextEvent()

void wxKeyEvent::DoAllowNextEvent | ( |  | ) |

Allow normal key events generation.

Can be called from `wxEVT_CHAR_HOOK` handler to indicate that the generation of normal events should not be suppressed, as it happens by default when this event is handled.

The intended use of this method is to allow some window object to prevent `wxEVT_CHAR_HOOK` handler in its parent window from running by defining its own handler for this event. Without calling this method, this would result in not generating `wxEVT_KEY_DOWN` nor `wxEVT_CHAR` events at all but by calling it you can ensure that these events would still be generated, even if `wxEVT_CHAR_HOOK` event was handled.

Since
  2.9.3

## ◆ GetKeyCode()

int wxKeyEvent::GetKeyCode | ( |  | ) | const

Returns the key code of the key that generated this event.

ASCII symbols return normal ASCII values, while events from special keys such as "left cursor arrow" (`WXK_LEFT`) return values outside of the ASCII range. See wxKeyCode for a full list of the virtual key codes.

Note that this method returns a meaningful value only for special non-alphanumeric keys or if the user entered a Latin-1 character (this includes ASCII and the accented letters found in Western European languages but not letters of other alphabets such as e.g. Cyrillic). Otherwise it simply method returns `WXK_NONE` and GetUnicodeKey() should be used to obtain the corresponding Unicode character.

Using GetUnicodeKey() is in general the right thing to do if you are interested in the characters typed by the user, GetKeyCode() should be only used for special keys (for which GetUnicodeKey() returns `WXK_NONE`). To handle both kinds of keys you might write:

void MyHandler::OnChar(wxKeyEvent& event)
{
wxChar uc = event.GetUnicodeKey();
if ( uc != WXK_NONE )
{
// It's a "normal" character. Notice that this includes
// control characters in 1..31 range, e.g. WXK_RETURN or
// WXK_BACK, so check for them explicitly.
if ( uc >= 32 )
{
wxLogMessage("You pressed '%c'", uc);
}
else
{
// It's a control character
...
}
}
else // No Unicode equivalent.
{
// It's a special key, deal with all the known ones:
switch ( event.GetKeyCode() )
{
case WXK_LEFT:
case WXK_RIGHT:
... move cursor ...
break;
case WXK_F1:
... give help ...
break;
}
}
}
wxChar
wxUSE_UNICODE_dependent wxChar
wxChar is defined to be - char when wxUSE_UNICODE==0 - wchar_t when wxUSE_UNICODE==1 (the default).
Definition chartype.h:105
wxKeyEvent::GetKeyCode
int GetKeyCode() const
Returns the key code of the key that generated this event.
wxKeyEvent::wxKeyEvent
wxKeyEvent(wxEventType keyEventType=wxEVT_NULL)
Constructor.
WXK_NONE
@ WXK_NONE
No key.
Definition defs.h:883
WXK_LEFT
@ WXK_LEFT
Definition defs.h:953
WXK_F1
@ WXK_F1
Definition defs.h:979
WXK_RIGHT
@ WXK_RIGHT
Definition defs.h:955
wxLogMessage
void wxLogMessage(const char *formatString,...)
For all normal, informational messages.

## ◆ GetPosition() [1/2]

wxPoint wxKeyEvent::GetPosition | ( |  | ) | const

Obtains the position (in client coordinates) at which the key was pressed.

Notice that under most platforms this position is simply the current mouse pointer position and has no special relationship to the key event itself.

x and y may be NULL if the corresponding coordinate is not needed.

## ◆ GetPosition() [2/2]

void wxKeyEvent::GetPosition | ( | wxCoord * | x,
|  | wxCoord * | y ) const

## ◆ GetRawKeyCode()

wxUint32 wxKeyEvent::GetRawKeyCode | ( |  | ) | const

Returns the raw key code for this event.

The flags are platform-dependent and should only be used if the functionality provided by other wxKeyEvent methods is insufficient.

Under MSW, the raw key code is the value of `wParam` parameter of the corresponding message.

Under GTK, the raw key code is the `keyval` field of the corresponding GDK event.

Under macOS, the raw key code is the `keyCode` field of the corresponding NSEvent.

Note
  Currently the raw key codes are not supported by all ports, use #ifdef wxHAS_RAW_KEY_CODES to determine if this feature is available.

## ◆ GetRawKeyFlags()

wxUint32 wxKeyEvent::GetRawKeyFlags | ( |  | ) | const

Returns the low level key flags for this event.

The flags are platform-dependent and should only be used if the functionality provided by other wxKeyEvent methods is insufficient.

Under MSW, the raw flags are just the value of `lParam` parameter of the corresponding message.

Under GTK, the raw flags contain the `hardware_keycode` field of the corresponding GDK event.

Under macOS, the raw flags contain the modifiers state.

Note
  Currently the raw key flags are not supported by all ports, use #ifdef wxHAS_RAW_KEY_CODES to determine if this feature is available.

## ◆ GetUnicodeKey()

wxChar wxKeyEvent::GetUnicodeKey | ( |  | ) | const

Returns the Unicode character corresponding to this key event.

If the key pressed doesn't have any character value (e.g. a cursor key) this method will return `WXK_NONE`. In this case you should use GetKeyCode() to retrieve the value of the key.

This function is only available in Unicode build, i.e. when `wxUSE_UNICODE` is 1.

## ◆ GetX()

wxCoord wxKeyEvent::GetX | ( |  | ) | const

Returns the X position (in client coordinates) of the event.

See also
  GetPosition()

## ◆ GetY()

wxCoord wxKeyEvent::GetY | ( |  | ) | const

Returns the Y position (in client coordinates) of the event.

See also
  GetPosition()

## ◆ IsKeyInCategory()

bool wxKeyEvent::IsKeyInCategory | ( | int | category | ) | const

Returns true if the key is in the given key category.

Parameters

  category | A bitwise combination of named wxKeyCategoryFlags constants.

Since
  2.9.1

## ◆ IsNextEventAllowed()

bool wxKeyEvent::IsNextEventAllowed | ( |  | ) | const

Returns true if DoAllowNextEvent() had been called, false by default.

This method is used by wxWidgets itself to determine whether the normal key events should be generated after `wxEVT_CHAR_HOOK` processing.

Since
  2.9.3